#
# Copyright 2008 TKK/ComNet
# Released under GPLv3. See LICENSE.txt for details.
#

require File.dirname(__FILE__) + '/spec_helper'

describe Cache do
  
  before(:all) do
    @test_file = '/test.html'
    @test_file_content = File.read(Resource.full_path_to(@test_file))    
  end
    
  it "should raise error when attempting to go outside cache root" do
    lambda { Cache.fetch("../spec/helper.rb") }.should raise_error
    lambda { Cache.store("../malicious.txt", "DATA") }.should raise_error
  end
  
  it "should store files on disk" do
    Cache.store(@test_file, @test_file_content)
    File.exist?(Cache.full_path_to(@test_file)).should be_true
  end
  
  it "should fetch files from disk" do
    # Don't check for staleness (metadata doesn't exist)
    Cache.fetch(@test_file, false).should == @test_file_content
  end
  
  after(:all) do
    Cache.clear
  end
end
